function varargout = Processing(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Processing_OpeningFcn, ...
    'gui_OutputFcn',  @Processing_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
end
function Processing_OpeningFcn(hObject, eventdata, handles, varargin)
    global stop;
    handles.output = hObject;
    guidata(hObject, handles);
    
    %uiwait(handles.figure1);
    scrsz = get(0,'ScreenSize');
     set(gcf,'Position',scrsz);
    open('PPT.exe')
    stop=0;
    set(handles.pushbutton4,'enable','off');
    set(handles.pushbutton3,'enable','off');
    set(handles.pushbutton8,'visible','off');
    set(handles.pushbutton1,'visible','off');
    set(handles.axes1,'xtick',[]);
    set(handles.axes1,'ytick',[]);
    set(handles.axes1,'box','on');
    open('Receive.exe')%׼߽ļ
    
end
function varargout = Processing_OutputFcn(hObject, eventdata, handles) 
    varargout{1} = handles.output;
end
function pushbutton1_Callback(hObject, eventdata, handles)%
    global stop
    stop=1;
end
function pushbutton6_Callback(hObject, eventdata, handles)%߽ļ
    global nframes filename filepath base_frame width0 height0 video_frame stop
    setDisabled(handles);
    nframes=0;filename='';filepath='';base_frame=0;width0=0;height0=0;
    try
        video=VideoReader('temp.avi');
        base_frame = read(video, 1);
        video_frame = read(video);
        imshow(base_frame)
        nframes = get(video, 'NumberOfFrames');%֡
        width0=size(base_frame,2);height0=size(base_frame,1);
        set(handles.text7,'string','Ƶļճɹ');
        set(handles.text8,'string',[ 'ԶƵļ' '    ' int2str(width0) '*' int2str(height0) '  ' int2str(nframes) '֡' ]);
    catch
        set(handles.text7,'string','ʧܣWiFiǷ');
    end
    
    set(handles.pushbutton1,'position',get(hObject,'position'));
    set(handles.pushbutton1,'visible','on');%ءť
    try
        if get(handles.checkbox1,'value')>0.5
            for k=1:size(video_frame,4)
                if stop==0
                imshow(video_frame(:,:,:,k))
                pause(0.01)
                end
            end
        end
    catch
        set(handles.text7,'string','Ƶļ޷');
    end
    set(handles.pushbutton1,'visible','off');%ءť
    set(handles.pushbutton8,'visible','off');
    setEnabled(handles);
    stop=0;
end

function pushbutton2_Callback(hObject, eventdata, handles) %򿪱Ƶļ
    global nframes filename filepath base_frame  width0 height0 video_frame stop
    nframes=0;filename='';filepath='';base_frame=0;width0=0;height0=0;
    setDisabled(handles);
    try
       
            [filename filepath]=uigetfile('*.avi','ѡƵļ');
            video=VideoReader([filepath filename]);
            base_frame = read(video, 1);
            video_frame = read(video);
            imshow(base_frame)
            nframes=size(video_frame,4);
            width0=size(base_frame,2);height0=size(base_frame,1);
            set(handles.text7,'string','Ƶļȡɹ');
            set(handles.text8,'string',[ filepath filename '    ' int2str(width0) '*' int2str(height0) '  ' int2str(nframes) '֡' ]);

    catch
        set(handles.text7,'string','ļûд򿪣');
    end
    
    set(handles.pushbutton1,'position',get(hObject,'position'));
    set(handles.pushbutton1,'visible','on');%ءť
    try
        if get(handles.checkbox1,'value')>0.5 
            for k=1:size(video_frame,4)
                if stop==0
                imshow(video_frame(:,:,:,k))
                pause(0.01)
                end
            end
        end
    catch
        set(handles.text7,'string','Ƶļ޷');
    end
    setEnabled(handles);
    set(handles.pushbutton1,'visible','off');
    set(handles.pushbutton8,'visible','off');
    stop=0;
    
end
function pushbutton4_Callback(hObject, eventdata, handles)%תͼ
    global nframes video_frame base_frame  width0 height0  maxdev maxwidth base_points pic points_num step result_frame stop
    setDisabled(handles);
    result_frame=0;
    if get(handles.radiobutton5,'value')<0.5 %ѡ׼ûѡУҪԶֶ׼
        points_num=0;%׼
        if get(handles.radiobutton6,'value')>0.5
            points_num=2;
        elseif get(handles.radiobutton7,'value')>0.5
            points_num=3;
        elseif get(handles.radiobutton8,'value')>0.5
            points_num=4;
        elseif get(handles.radiobutton9,'value')>0.5
            points_num=5;
        elseif get(handles.radiobutton10,'value')>0.5
            points_num=6;
        elseif get(handles.radiobutton11,'value')>0.5
            points_num=7;
        end
        add_points_num=0;
        if points_num>4
            add_points_num=points_num-4;
            points_num=4;
        end
        
        order=randperm(nframes-1)+1;
        
        ratio=str2double(get(handles.edit4,'string'));
        maxdev=str2double(get(handles.edit2,'string'));
        maxwidth=str2double(get(handles.edit3,'string'));
        maxvalid=str2double(get(handles.edit1,'string'));
        
        step=floor(maxwidth/15)+1;
        xre=floor((1-ratio)/2*width0);yre=floor((1-ratio)/2*height0);
        
        result_frame=base_frame(1+yre:yre+floor(height0*ratio),1+xre:xre+floor(width0*ratio),:);
    
        valid_num=1;
        if get(handles.radiobutton3,'value')>0.5 
            base_points=ChoosePoints(base_frame,points_num+add_points_num,height0,width0,maxdev,maxwidth);
        else
            base_points=ChoosePoints(base_frame,points_num,height0,width0,maxdev,maxwidth);
        end
        set(handles.text7,'string','׼ѡϣ׼ת');
    
        k=1;
        hold off
        
        set(handles.pushbutton1,'visible','on');%ءť
        set(handles.pushbutton1,'position',get(hObject,'position'));
        
        while k<=nframes-1 && valid_num < maxvalid && stop==0
            set(handles.text7,'string',['Ѷȡ' int2str(k) 'ͼ' int2str(valid_num) 'Ч']);
            input_frame=video_frame(:,:,:,order(k));
            [regframe,issucess]=registrate(input_frame,base_frame,base_points,ratio,handles);
            if issucess==1
                valid_num=valid_num+1;
                result_frame(:,:,:,valid_num)=regframe;
            end
            k=k+1;       
        end
        set(handles.pushbutton1,'visible','off');%ءť
        set(handles.text7,'string',['ȡ' int2str(valid_num) 'ЧͼתС']);
        pause(0.01)
        pic=median(result_frame,4);    
    elseif get(handles.radiobutton5,'value')>0.5 %ѡ򡰲׼ѡ
        result_frame=video_frame;
        pic=median(result_frame,4);
        set(handles.pushbutton8,'visible','on');%ť
        set(handles.pushbutton8,'position',get(hObject,'position'));
    end
    hold off
    imshow(uint8(pic))
    set(handles.text7,'string',['ת,ͼߴΪ' int2str(size(pic,2)) '*' int2str(size(pic,1))]);
    
    setEnabled(handles);
    stop=0;
end
function pushbutton3_Callback(hObject, eventdata, handles)%ͼ
    global pic stop
    [filename filepath]=uiputfile('*.jpg','ѡļͱ·');
    imwrite(pic,[filepath filename]);
    stop=0;
end
function pushbutton7_Callback(hObject, eventdata, handles)%ʵʱͼ
    global stop vid 
    setDisabled(handles);
    set(handles.pushbutton1,'position',get(hObject,'position'));
    set(handles.pushbutton1,'visible','on');%ءť
    set(handles.text7,'string','ͷ');
    pause(0.1);

    nframes=20;
    try
        vid = videoinput('winvideo', 1, 'YUY2_640x480');
    catch
    end
    set(handles.text7,'string','ͷ');
    pause(0.1);
    set(vid,'ReturnedColorSpace','rgb');
    vidRes=get(vid,'VideoResolution');
    nBands=get(vid,'NumberOfBands');
    %hImage=image(zeros(vidRes(1),vidRes(2),nBands));
    
    preview(vid);
    video_frame=ones(480,640,3,nframes);
    
   
    set(handles.text7,'string','ͷ');
    pause(0.1);
    k=0;
    %for k=1:nframes 
        while stop==0
            k=k+1;
            if k>=5 
                pic0=pic;
            end
            f=getsnapshot(vid);
            video_frame(:,:,:,k)=f;
            pic=median(video_frame(:,:,:,1:k),4);
            imshow(uint8(pic))
            set(handles.text7,'string',['Ѷȡ' int2str(k) 'ͼ']);
            if k>=5 && sum(sum(sum(abs(double(pic0)-double(pic))))) <= size(pic,1)*size(pic,2)*3*1
                stop=1;
                set(handles.text7,'string',['ȡ' int2str(k) 'ͼת']);
            end
            if k<20
                pause(0.2);
            else
                pause(0.01);
            end
        end
    %end
    
    setEnabled(handles);
    set(handles.pushbutton1,'visible','off');%ءť
    stop=0;
end

function pushbutton8_Callback(hObject, eventdata, handles)
    global pic result_frame stop
    setDisabled(handles);
    set(handles.pushbutton1,'position',get(hObject,'position'));
    set(handles.pushbutton1,'visible','on');%ءť
    try
        for k=1:size(result_frame,4)
            if stop==0
                imshow(result_frame(:,:,:,k)-pic)
                pause(0.01)
            end
        end
    catch
        set(handles.text7,'string','޷ţ');
    end
    set(handles.pushbutton1,'visible','off');%ءť
    set(handles.pushbutton8,'visible','off');%ť
    stop=0;
    setEnabled(handles);
end
function setEnabled(handles)
    set(handles.pushbutton3,'enable','on');
    set(handles.pushbutton6,'enable','on');
    set(handles.pushbutton4,'enable','on');
    set(handles.pushbutton2,'enable','on');
    set(handles.pushbutton7,'enable','on');
    set(handles.pushbutton8,'enable','on');
end
function setDisabled(handles)
    set(handles.pushbutton3,'enable','off');
    set(handles.pushbutton6,'enable','off');
    set(handles.pushbutton4,'enable','off');
    set(handles.pushbutton2,'enable','off');
    set(handles.pushbutton7,'enable','off');
    set(handles.pushbutton8,'enable','off');
end
function base_points=ChoosePoints(base_frame,num,height,width,maxdev,maxwidth)
    global stop
    imshow(uint8(base_frame)),hold on
    rectangle('Position',[maxdev+maxwidth,maxdev+maxwidth,width-2*(maxdev+maxwidth),height-2*(maxdev+maxwidth)],'edgecolor','w')
    handles=guihandles();
    set(handles.text7,'string','ڷѡȡ׼');

    for m=1:num
        if stop==0
            [x,y]=ginput(1);
            while x<=maxdev+maxwidth || y<=maxdev+maxwidth || y>=height-(maxdev+maxwidth) || x>=width-(maxdev+maxwidth)
                set(handles.text7,'string','׼㳬Χѡ');
                [x,y]=ginput(1);       
            end
            base_points(m,:)=[floor(x) floor(y)];
            plot(x,y,'or')
        end
    end
    pause(0.5)

end
function result = rgb_robert(rgb_image)
    rgb_image=double(rgb2gray(rgb_image));
    w1=[-1 0;0 1];
    w2=[0 -1;1 0];
    G1=imfilter(rgb_image,w1,'corr','replicate');
    G2=imfilter(rgb_image,w2,'corr','replicate');
    result=abs(G1)+abs(G2);
end
function result = rgb_sobel(rgb_image)
    rgb_image=double(rgb2gray(rgb_image));
    w1=fspecial('sobel');w2=w1';
    G1=imfilter(rgb_image,w1);
    G2=imfilter(rgb_image,w2);
    result=abs(G1)+abs(G2);
end
function [valid_input_point,valid_base_point,sorted_devmin,block_size]=find_similar(base_point,map1,map2,maxdev,maxwidth,number)
    global step
    valid_input_point=zeros(number,2);
    valid_base_point=zeros(number,2);
    devmin=zeros(1,size(base_point,1));

    
    for k=1:size(base_point,1)
        x1=base_point(k,1);y1=base_point(k,2);
        temp1=map1(y1-maxwidth:step:y1+maxwidth,x1-maxwidth:step:x1+maxwidth,:);
        for x2=x1-maxdev:x1+maxdev
            for y2=y1-maxdev:y1+maxdev
                temp2=map2(y2-maxwidth:step:y2+maxwidth,x2-maxwidth:step:x2+maxwidth,:);

                %temp2temp1ΪuintͣǰdoubleֱֵΪ0û
                dev(y2+maxdev+1-y1,x2+maxdev+1-x1)=sum(sum(sum(abs(double(temp2)-double(temp1)))));
                %dev(y2+maxdev+1-y1,x2+maxdev+1-x1)=sum(sum(abs(double(temp2)-double(temp1))));
            end
        end
        
        devmin(k)=min(min(dev));
        [m,n]=find(dev==devmin(k)); 
        m=m(1,1);n=n(1,1);%ȷmnֻһֵ
        y2=y1+m-maxdev-1;
        x2=x1+n-maxdev-1;
        temp_input_point(k,:)=[x2 y2];
    end
    block_size=size(dev,1)*size(dev,2)*size(dev,3);    
    [sorted_devmin,index]=sort(devmin);
    %sorted_devmin
    for k=1:number
        valid_input_point=[valid_input_point;temp_input_point(index(k),:)];
        valid_base_point=[valid_base_point;base_point(index(k),:)];
    end
end
function [reg,issucess]=registrate(input_frame,base_frame,base_points,ratio,guihand)
    %frameΪ֡ͼԵһ֡Ϊ׼base_pointsΪ׼22УÿһΪһ׼
    global maxdev maxdelta maxwidth points_num
    issucess=0;
    reg=0;
    [height,width,~]=size(base_frame);
    if get(guihand.radiobutton3,'value')>0.5 
        [valid_input_points,valid_base_points,sorted_devmin,block_size]=find_similar(base_points,base_frame,input_frame,maxdev,maxwidth,points_num);
    else
        valid_base_points=base_points;
        valid_input_points=ChoosePoints(input_frame,points_num,height,width,maxdev,maxwidth);
    end
    
    if points_num==2
        tform=cp2tform(valid_input_points,valid_base_points,'linear');
    elseif points_num==3
        tform=cp2tform(valid_input_points,valid_base_points,'affine');
    elseif points_num==4
        tform=cp2tform(valid_input_points,valid_base_points,'Projective');
    end
    regtemp=uint8(imtransform(input_frame,tform,'bicubic','XData',[1,width],'YData',[1,height])); 
    hold on
    imshow(uint8(input_frame))
    plot(valid_input_points(:,1),valid_input_points(:,2),'og')
    pause(0.1)
    hold off
    if get(guihand.radiobutton4,'value')>0.5 || sorted_devmin(points_num)<5*block_size % size(regtemp0,2)<width*1.03 && abs(mean_dev(1))<=maxdelta && abs(mean_dev(2))<=maxdelta 
        xre=floor((1-ratio)/2*width);yre=floor((1-ratio)/2*height);
        issucess=1;
        reg=regtemp(1+yre:yre+floor(height*ratio),1+xre:xre+floor(width*ratio),:);
    end
end

% 
% % --- Executes during object creation, after setting all properties.
% function uipanel3_CreateFcn(hObject, eventdata, handles)
% % hObject    handle to uipanel3 (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    empty - handles not created until after all CreateFcns called
% end
% 
% 
% 
% function edit6_Callback(hObject, eventdata, handles)
% % hObject    handle to edit6 (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% 
% % Hints: get(hObject,'String') returns contents of edit6 as text
% %        str2double(get(hObject,'String')) returns contents of edit6 as a double
% end
% 
% %--- Executes during object creation, after setting all properties.
% function edit6_CreateFcn(hObject, eventdata, handles)
% % hObject    handle to edit6 (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    empty - handles not created until after all CreateFcns called
% % 
% % Hint: edit controls usually have a white background on Windows.
% %       See ISPC and COMPUTER.
% 
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end
% end
% 
% 
% 
% function edit7_Callback(hObject, eventdata, handles)
% end
% 
% function edit7_CreateFcn(hObject, eventdata, handles)
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end
% end
% 
% 
% % --- Executes on button press in checkbox1.
% function checkbox1_Callback(hObject, eventdata, handles)
% % hObject    handle to checkbox1 (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% 
% % Hint: get(hObject,'Value') returns toggle state of checkbox1
% end


% --- Executes on button press in pushbutton7.


% --- Executes on button press in pushbutton8.


% --- Executes on button press in pushbutton1.
