package receive;
import java.io.DataInputStream;  
import java.io.File;  
import java.io.FileOutputStream;  
import java.io.IOException;  
import java.net.ServerSocket;  
import java.net.Socket;  

import javax.swing.JOptionPane;

public class Receive {
	public static void main(String[] args) {  
        try {  
            final ServerSocket server = new ServerSocket(15425);
            Thread th = new Thread(new Runnable() {  
                public void run() {  
                    while (true) {  
                        try {    
                            System.out.println("ʼ...");  
                            Socket socket = server.accept();  
                            System.out.println(""); 
                            receiveFile(socket);  
                        } catch (Exception e) {   
                            JOptionPane.showMessageDialog(null, "쳣:"+e);
                        }  
                    }  
                }  
            });  
            th.run(); //߳  
        } catch (Exception e) {  
        	JOptionPane.showMessageDialog(null, "쳣:"+e);
        }       
    }  

	public void run() {  
    	
    }
    public static void receiveFile(Socket socket) throws IOException {  
        byte[] inputByte = null;  
        int length = 0;  
        long total_length=0;
        int state=0;
        DataInputStream dis = null;  
        FileOutputStream fos = null;  
        String filePath = "";  
        try {  
            try {  
            	inputByte = new byte[1024]; 
                dis = new DataInputStream(socket.getInputStream());  
                dis.read(inputByte, 0, 4);
                state=inputByte[0]+(inputByte[1]<<8)+(inputByte[2]<<16)+(inputByte[3]<<24);
                if (state==0)
                	filePath="temp.avi";
                else
                	filePath="temp ("+Integer.toString(state)+").jpg";
                fos = new FileOutputStream(new File(filePath));      
                    
                System.out.println("ʼ...");   
                
                while ((length = dis.read(inputByte, 0, inputByte.length)) > 0) {  
                    fos.write(inputByte, 0, length);  
                    fos.flush();  
                    total_length++;
                    if(total_length%1024==0)
                    	System.out.println("ѽ"+total_length/1024+"MB");  
                }  
                System.out.println("ɽգ"+filePath);  
            } finally {  
                if (fos != null)  
                    fos.close();  
                if (dis != null)  
                    dis.close();  
                if (socket != null)  
                    socket.close();   
            }  
        } catch (Exception e) {  
        	JOptionPane.showMessageDialog(null, "쳣:"+e);
        }  
    }
}
