package litianyi.sendfile;

import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.StrictMode;
import android.preference.EditTextPreference;
import android.provider.MediaStore;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.MediaController;
import android.widget.TextView;
import android.widget.Button;
import java.io.*;
import java.net.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;

import java.io.File;

import java.util.HashMap;

import java.util.Map;

import android.app.Dialog;
import android.widget.Toast;
import android.widget.VideoView;
import android.media.MediaMetadataRetriever;
public class MainActivity extends ActionBarActivity {
    private static Socket sock;
    private static PrintWriter out;
    static private int openfileDialogId = 0;
    public long current_length=0;
    public long total_length=0;
    public char state=0;//文件状态，0表示单个视频，1表示图片

    // @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        EditText text=(EditText)findViewById(R.id.editText);
        text.setText("192.168.191.1");
        final Button btn=(Button)findViewById(R.id.button);
        final Button btn2=(Button)findViewById(R.id.button2);
        final Button btn3=(Button)findViewById(R.id.button3);
        final Button btn4=(Button)findViewById(R.id.button4);
        final TextView tip=(TextView)findViewById(R.id.textView2);
        final VideoView videoView = (VideoView)findViewById(R.id.videoView);
        final MediaController mController=new MediaController(this);
        videoView.setMediaController(new MediaController(this));
        btn.setOnClickListener(new View.OnClickListener(){
            public void onClick(View v) {
                int a = 0;
                state=0;//传单个视频
                Button btn = (Button) findViewById(R.id.button);
                btn.setText("button clicked!");
                btn.setClickable(false);
                try {
                    ThreadSend t1 = new ThreadSend("Send");
                    t1.start();
                    while(t1.isAlive()) {
                        Thread.sleep(10);
                        tip.setText(btn.getText());
                    }
                }catch (Exception e){
                    tip.setText("传输失败:"+e);
                }
                btn.setText("");
                btn.setClickable(true);
            }
        });
        btn2.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                try {
                    showDialog(openfileDialogId);
                }catch(Exception e){
                    tip.setText("文件读取失败:"+e);
                }
            }
        });
        btn3.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                startActivityForResult(intent, 1);
            }
        });
        btn4.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                try {
                    videoView.setVisibility(View.VISIBLE);
                    TextView textview = (TextView) findViewById(R.id.textView3);
                    String path = textview.getText().toString();
                    videoView.setVideoPath(path);
                    videoView.start();
                    videoView.requestFocus();
                }catch(Exception e){
                    tip.setText("视频播放失败:"+e);
                }

                /*
                try {
                    while(videoView.isPlaying()) {
                        Thread.sleep(10);
                        Bitmap pic=videoView.getDrawingCache();
                        String local_file = Environment.getExternalStorageDirectory().getAbsolutePath()+"/down/";
                        File f = new File(local_file);
                        if(!f.exists()){
                            f.mkdirs();
                        }
                        local_file = f.getAbsolutePath()+"/"+"001.png";
                        f = new File(local_file);
                        try {
                            if(!f.createNewFile()) {
                                System.out.println("File already exists");
                            }
                        } catch (IOException ex) {
                            System.out.println(ex);
                        }

                        //File f = new File(Environment.getExternalStorageDirectory().getPath()+"map.png");
                        //f.createNewFile();
                        FileOutputStream fOut = null;
                        try {
                            fOut = new FileOutputStream(f);
                        } catch (FileNotFoundException e) {
                            tip.setText("截取视频失败:"+e);
                        }
                        pic.compress(Bitmap.CompressFormat.PNG, 100, fOut);

                        tip.setText(btn.getText());
                    }
                }catch (Exception e){
                    tip.setText("传输失败:"+e);
                }*/
            }
        });
    }
    //在handler中更新UI
    /*
    class testThread extends Thread{
        public void run() {
            Message message = new Message();
            mHandler.sendMessage(message);
        }
    }
    private Handler mHandler = new Handler(){
        public void handleMessage(Message msg) {
            TextView tip=(TextView)findViewById(R.id.textView2);
            tip.setText("想变的内容");
        };
    };*/
    protected Dialog onCreateDialog(int id) {
        if(id==openfileDialogId){
            Map<String, Integer> images = new HashMap<String, Integer>();
            // 下面几句设置各文件类型的图标， 需要你先把图标添加到资源文件夹
            images.put(OpenFileDialog.sRoot, R.drawable.card);
            images.put(OpenFileDialog.sParent, R.drawable.up);    //返回上一层的图标
            images.put(OpenFileDialog.sFolder, R.drawable.file);   //文件夹图标
            images.put("wav", R.drawable.movie);   //wav文件图标
            images.put(OpenFileDialog.sEmpty, R.drawable.movie);
            Dialog dialog = OpenFileDialog.createDialog(id, this, "打开文件", new CallbackBundle() {
                @Override
                public void callback(Bundle bundle) {
                    String filepath = bundle.getString("path");
                    TextView textview=(TextView)findViewById(R.id.textView);
                    TextView textview3=(TextView)findViewById(R.id.textView3);
                    TextView tip=(TextView)findViewById(R.id.textView2);
                    VideoView videoView = (VideoView)findViewById(R.id.videoView);
                    File file = new File(filepath);
                    long l = file.length();
                    textview3.setText(filepath);
                    textview.setText("文件大小："+l/1024+"KB\n\n文件路径："+filepath);
                    tip.setText("视频读取成功");
                    try {
                        videoView.setVisibility(View.VISIBLE);
                        String path = textview3.getText().toString();
                        videoView.setVideoPath(path);
                        videoView.start();
                        videoView.requestFocus();
                        //videoView.pause();
                    }catch(Exception e){
                        tip.setText("视频读取失败:"+e);
                    }
                }
            },".mp4;",images);
            return dialog;
        }
        return null;
    }

    class ThreadSend extends Thread {
        ThreadSend(String s) {
            super(s);
        }
        public void run() {

            Button btn=(Button)findViewById(R.id.button);
            EditText text=(EditText)findViewById(R.id.editText);

            //btn.setText("thread entered");

            int length = 0;
            double sumL = 0 ;
            byte[] sendBytes = null;
            Socket socket = null;
            DataOutputStream dos = null;
            FileInputStream fis = null;
            boolean bool = false;
            try {
                TextView textview =(TextView)findViewById(R.id.textView3);
                String path=textview.getText().toString();

                File file = new File(path);
                long l = file.length();
                total_length=l;
                if(l>0) {
                    //btn.setText("文件长度：" + l);
                    Thread.sleep(50);
                    socket = new Socket();
                    String IP = text.getText().toString();
                    socket.connect(new InetSocketAddress(IP, 15425),3000);//设置超时时间3000 ms
                    dos = new DataOutputStream(socket.getOutputStream());
                    fis = new FileInputStream(file);
                    sendBytes = new byte[1024];
                    sendBytes[0]=(byte)(state&0xff);
                    sendBytes[1]=(byte)((state>>8)&0xff);
                    sendBytes[2]=(byte)((state>>16)&0xff);
                    sendBytes[3]=(byte)((state>>24)&0xff);

                    dos.write(sendBytes, 0, 4);
                    dos.flush();
                    while ((length = fis.read(sendBytes, 0, sendBytes.length)) > 0) {
                        sumL += length;
                        //btn.setText("已传输：" + ((sumL / l) * 100) + "%");
                        dos.write(sendBytes, 0, length);
                        dos.flush();
                        //Thread.sleep(5);
                    }
                    //btn.setText("传输长度：" + sumL);
                    //虽然数据类型不同，但JAVA会自动转换成相同数据类型后做比较
                    if (sumL == l) {
                        bool = true;
                        btn.setText("传输成功!");

                    }
                }
                else{
                    btn.setText("文件不存在");
                }

            }catch (Exception e) {
                btn.setText("文件传输时出现异常:"+e);
                bool = false;
            }
            finally{
                try {
                    if (dos != null)
                        dos.close();
                    if (fis != null)
                        fis.close();
                    if (socket != null)
                        socket.close();
                }catch(Exception e){
                    btn.setText("关闭连接时出现异常:"+e);
                }
            }
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
